var StatusImages = new Array();
StatusImages["NLN"] = "chrome://msnmsgr/skin/status/online.png";
StatusImages["AWY"] = "chrome://msnmsgr/skin/status/away.png";
StatusImages["BRB"] = "chrome://msnmsgr/skin/status/away.png";
StatusImages["BSY"] = "chrome://msnmsgr/skin/status/busy.png";
StatusImages["PHN"] = "chrome://msnmsgr/skin/status/busy.png";
StatusImages["LUN"] = "chrome://msnmsgr/skin/status/busy.png";
StatusImages["IDL"] = "chrome://msnmsgr/skin/status/idle.png";
StatusImages["HDN"] = "chrome://msnmsgr/skin/status/offline.png";
StatusImages["FLN"] = "chrome://msnmsgr/skin/status/offline.png";
StatusImages["BLK"] = "chrome://msnmsgr/skin/status/blocked.png";

var Emoticons = new Array();
Emoticons[':D'] = "chrome://msnmsgr/skin/emoticons/bigsmile.png";
Emoticons[':S'] = "chrome://msnmsgr/skin/emoticons/confused.png";
Emoticons[':)'] = "chrome://msnmsgr/skin/emoticons/happy.png";
Emoticons[':('] = "chrome://msnmsgr/skin/emoticons/sad.png";
Emoticons[':O'] = "chrome://msnmsgr/skin/emoticons/suprised.png";
Emoticons[';)'] = "chrome://msnmsgr/skin/emoticons/wink.png";
Emoticons[':|'] = "chrome://msnmsgr/skin/emoticons/disappointed.png";
Emoticons[':P'] = "chrome://msnmsgr/skin/emoticons/stickouttongue.png";

const XHTML = "http://www.w3.org/1999/xhtml";

const PREF_CTRID = "@mozilla.org/preferences-service;1";
const nsIPrefService = Components.interfaces.nsIPrefService;
const nsIPrefBranch = Components.interfaces.nsIPrefBranch;
const nsIPrefBranchInternal = Components.interfaces.nsIPrefBranchInternal;
const prefService = Components.classes[PREF_CTRID].getService(nsIPrefService);
const prefBranch = prefService.getBranch("extensions.msnmsgr.");

function getStringBundle(path) {
    var strBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].
        getService(Components.interfaces.nsIStringBundleService);

    return strBundleService.createBundle(path); 
}

function getMainWindow()
{
    var wmediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
        getService(Components.interfaces.nsIWindowMediator);

    return wmediator.getMostRecentWindow( "msnmsgr:contact-list" );
}

function openPrefsWindow(containerID, paneURL, itemID)
{
    const kWindowMediatorContractID = "@mozilla.org/appshell/window-mediator;1";
    const kWindowMediatorIID = Components.interfaces.nsIWindowMediator;
    const kWindowMediator = Components.classes[kWindowMediatorContractID].getService(kWindowMediatorIID);
    var lastPrefWindow = kWindowMediator.getMostRecentWindow("mozilla:preferences");
    if (lastPrefWindow)
        lastPrefWindow.focus();
    else {
        var features = "chrome,titlebar,resizable=yes";
        openDialog("chrome://communicator/content/pref/pref.xul","PrefWindow", 
                   features, paneURL, containerID, itemID);
    }
}

function openWindowOnce(url, type, features)
{
    const kWindowMediatorContractID = "@mozilla.org/appshell/window-mediator;1";
    const kWindowMediatorIID = Components.interfaces.nsIWindowMediator;
    const kWindowMediator = Components.classes[kWindowMediatorContractID].getService(kWindowMediatorIID);
    var lastPrefWindow = kWindowMediator.getMostRecentWindow(type);
    if (lastPrefWindow)
        lastPrefWindow.focus();
    else {
        window.open(url, type, features);
    }
}

function gotoURL(postURL, URL, id) {
    var win = window.open('about:blank');
    var form = win.document.createElement('form');
//    form.setAttribute('action', 'https://loginnet.passport.com/ppsecure/md5auth.srf?lc=1033');
    form.setAttribute('action', postURL);
    form.setAttribute('method', "POST");
    win.document.body.appendChild(form);
    
    function appendInput(n, v) {
        var i = win.document.createElement('input');
        i.setAttribute('type', 'hidden');
        i.setAttribute('name', n);
        i.setAttribute('value', v);
        //alert (n + " = " + v);
        form.appendChild(i);
    }
    
    appendInput('mode', 'ttl');
    appendInput('login', window.client.passport);
    appendInput('username', window.client.passport);
    appendInput('sid', window.client.profile['sid']);
    appendInput('kv', window.client.profile['kv']);
    appendInput('id', id);
    var time = new Date().getTime();
    time /= 1000;
    var sl = time.toFixed(0) - window.client.profile['LoginTime'];
    //alert(window.client.profile['LoginTime'] + '\n' + time.toFixed(0) + '\n' + sl);
    appendInput('sl', sl);
    appendInput('rru', URL);
    appendInput('auth', window.client.profile['MSPAuth']);
    var creds = window.client.profile['MSPAuth'] + sl + window.client.password;
    creds = hex_md5(creds);
    appendInput('creds', creds);
    appendInput('svc', 'mail');
    appendInput('js', 'yes');
    
    form.submit();
}

function parseHeaders(data) {
  var headers = new Array();
  var headerparts = data.split('\r\n');
  for (var i in headerparts) {
    var header = headerparts[i].split(": ");
    headers[header[0].toLowerCase()] = header[1];
    dump(header[0] + ": " + header[1] + '\r\n');
  }
  return headers;
}

function createMessageNode(doc, from, textObj, mymsg) {
  from += ":";
  var msg = doc.createElementNS(XHTML, 'div');
  msg.setAttribute('class', 'InstantMessage');
  var nFrom = doc.createElementNS(XHTML, 'div');
  var fNode = doc.createTextNode(from);
  nFrom.appendChild(fNode);
  if (mymsg == true) {
    nFrom.setAttribute('class', 'From FromMe');        
  }
  else {
    nFrom.setAttribute('class', 'From');
  }
  msg.appendChild(nFrom);
  if (typeof(textObj) == 'string')
    textObj = createMessageContentNode(doc, textObj);
  msg.appendChild(textObj);
  return msg;
}

function createMessageContentNode(doc, text, mms) {
  var msg = doc.createElementNS(XHTML, 'div');
  msg.setAttribute('class', 'message');
  if (typeof(mms) == "string") {
    var style = convertXMMStoStyle(mms)
    msg.setAttribute('style', style);
  }
  var start = 0;
  for (var i = 0; i < text.length; i++) {
    var letter = text.substr(i, 1);
    if (letter == ':') {
      i++;
      var letter = text.substr(i, 1).toUpperCase();
      if (')(DOSP|'.indexOf(letter) >= 0 && letter != "") {
        //add the text before the emote
        addText(text.substr(start, i - start - 1));
        start = i + 1;
        //add the emote
        var iNode = document.createElementNS(XHTML, 'img');
        iNode.setAttribute('src', Emoticons[':' + letter]);
        msg.appendChild(iNode);
      }
    }
    else if (letter == ';') {
      i++;
      var letter = text.substr(i, 1).toUpperCase();
      if (letter == ')') {
        //add the text before the emote
        addText(text.substr(start, i - start - 1));
        start = i + 1;
        //add the emote
        var imageNode = document.createElementNS(XHTML, 'img');
        imageNode.setAttribute('src', Emoticons[';' + letter]);
        msg.appendChild(imageNode);
      }
    }
  }
  if (start != i) {
    addText(text.substr(start, i - start));
  }
    
  function addText(t) {
    var textNode = doc.createTextNode(t);
    msg.appendChild(textNode);
  }

  return msg;
}

function createNotifyNode(doc, text) {
  var msg = doc.createElementNS(XHTML, 'div');
  msg.setAttribute('class', 'NotificationMessage');
  var textNode = doc.createTextNode(text);
  msg.appendChild(textNode);
  return msg;
}

function convertXMMStoStyle(mms) {
// X-MMS-IM-Format: FN=Tahoma; EF=B; CO=8000; CS=0; PF=22
    var params = mms.split('; ');
    var style = "";
    var style2 = "";
    for (var i in params) {
        i = params[i];
        var p = i.split('=');
        switch (p[0].toUpperCase()) {
            case 'FN':
                style += 'font-family: "' + unescape(p[1]) + '"; ';
                break;
            case 'EF':
                for (var i = 0; i < p[1].length; i++) {
                    var s = p[1].substr(i, 1);
                    switch (s.toUpperCase()) {
                        case 'B':
                            style += 'font-weight: bold; ';
                            break;
                        case 'I':
                            style += 'font-style: italic; ';
                            break;
                        case 'U':
                            style2 += ' underline';
                            break;
                        case 'S':
                            style2 += ' line-through';
                            break;
                    }
                }
                if (style2 != '')
                    style += 'text-decoration:' + style2 + '; ';
                break;
            case 'CO':
                c = '#000000'.substr(0, 7 - p[1].length) + p[1];
                style += 'color: ' + swapRedBlue(c) + '; ';
                break;
            case 'CS':
                
                break;
            case 'PF':
                
                break;
        }
    }
    return style;
}

function swapRedBlue (clr) {
    return '#' + clr.substr(5, 2) + clr.substr(3, 2) + clr.substr(1, 2);
}